##======================##
## Common File Launcher ##
##======================##
## Launcher-like FILER

#	.global launch_pass

	.equ 	GET_FILE_MAX 	, 100
	.equ 	PASS_RANGE 		, 50
	.equ 	LAUNCHER_SIZE 	, 60

file_launcher:
	jsr 	restore_vram
file_launcher_act_section: 						##==================< ACT
fas:
fas_up: 										#UP LOOP
	mov 	(flag_up),d0
	cmp 	1,d0
	bne 	fas_dw
	

	mov 	(file_max),d0
	cmp 	0,d0
	beq 	fas_up_end 							#EMPTY

	mov 	(file_num),d0
	cmp 	0,d0
	bne 	fas_up2
	mov 	(line_max),d0
	add 	-1,d0
	mov 	d0,(line_num)
	mov 	(file_max),d0
	add 	-1,d0
	mov 	d0,(file_num)

	mov 	(file_max),d1
	cmp 	6,d1
	bge 	fas_up_6over

	sub 	d1,d1
	jmp 	fas_up_in
fas_up_6over:
	mov 	6,d0
	sub 	d0,d1
fas_up_in:
	mov 	d1,(top_file_num)
	jmp 	fas_up_end
fas_up2:
	add 	-1,d0
	mov 	d0,(file_num)
	
	mov 	(line_num),d0
	cmp 	0,d0
	beq 	fas_up3
	add		-1,d0
	mov 	d0,(line_num)
	jmp 	fas_up_end
fas_up3:
	mov 	(top_file_num),d0
	add 	-1,d0
	mov 	d0,(top_file_num)
fas_up_end:
	jmp 	fas_end
fas_dw: 										#DW LOOP
	mov 	(flag_dw),d0
	cmp 	1,d0
	bne 	fas_le

	mov 	(file_max),d0
	cmp 	0,d0
	beq 	fas_dw_end 							#EMPTY

	mov 	(file_num),d0
	mov 	(file_max),d1
	add 	-1,d1
	cmp 	d1,d0
	bne 	fas_dw2
	sub 	d0,d0
	mov 	d0,(line_num)
	mov 	d0,(file_num)
	mov 	d0,(top_file_num)
	jmp 	fas_dw_end
fas_dw2:
	add 	1,d0
	mov		d0,(file_num)

	mov 	(line_num),d0
	cmp 	5,d0					#5=MAX
	beq 	fas_dw3

	add 	1,d0
	mov 	d0,(line_num)
	jmp 	fas_dw_end
fas_dw3:
	mov	 	(top_file_num),d0
	add 	1,d0
	mov 	d0,(top_file_num)
fas_dw_end:
	jmp	 	fas_end
fas_le:
	mov 	(flag_le),d0
	cmp 	1,d0
	bne 	fas_ri
	
	mov 	pass_name,a1
	mov 	limit_pass,a2
	mov 	(back_mode),d1
	jsr 	back_dir
	cmp 	1,d0 						#1:cancel
	beq 	fas_le2

	sub 	d0,d0
	mov 	d0,(flag_noload)
fas_le2:
	sub 	d0,d0
	mov 	d0,(file_num)
	mov 	d0,(line_num)
	mov 	d0,(top_file_num)
	
	jmp 	fas_end
fas_ri:
	mov 	(flag_ri),d0
	cmp 	1,d0
	bne 	fas_en

fas_ri_common:
	mov 	(file_max),d0 				#EMPTY
	cmp 	0,d0
	beq 	fas_end
	
	mov 	file_list,a1
	mov 	(file_num),d1
	
	add 	d1,d1
	add 	d1,d1 						#x4
#	mov 	4,d0
#	mulu 	d0,d1
	add 	d1,a1
	mov 	(a1),a0
	
	movbu 	(0,a0),d0
	btst 	0b00010000,d0 				#DIR?
	beq 	fas_ri_file
	
	add 	1,a0
	mov 	a0,a2
	mov 	pass_name,a1
	jsr 	next_dir
	
	sub	 	d0,d0
	mov 	d0,(file_num)
	mov 	d0,(line_num)
	mov		d0,(top_file_num)
	mov 	d0,(flag_noload)
	
	jmp 	fas_end
fas_ri_file:
	mov 	file_list,a2
	mov 	(file_num),d0
	add 	d0,d0
	add 	d0,d0
	add 	d0,a2
	mov 	(a2),a1
	add 	1,a1
	mov 	allowed_file_type,a2
	jsr 	check_ext
	cmp 	1,d0 							#1=not supported file
	beq 	fas_ri_nosupport
	cmp 	2,d0
	beq 	fas_ri_fatal 					#2=fatal error
fas_ri_file_go:
	mov 	launch_pass,a0
	mov 	pass_name,a1
	mov 	file_list,a2
	jsr 	create_launch_pass
	
	
	mov 	0xff,d0
	mov 	launch_pass,a1
	jsr 	call_dos_fnd_first
	cmp 	1,d0
	beq 	fas_end
	
	mov 	dta_area+26,a0
	mov 	launch_file_size,a1
	movx 	(0,a0),d0
	movx 	d0,(0,a1)
#	mov 	4,d1
#	jsr 	copy_data
	
	mov 	launch_pass,a1
	mov 	xbmmp_buffer,a2
	mov 	launch_file_size,a0
	movx 	(0,a0),d1
	jsr 	read_iny
	cmp 	1,d0
	beq 	exit
	
	mov 	xbmmp_buffer,a0
	mov 	xbmmp_mmp_buffer,a1
	mov 	xbmmp_mmp_info,a2
	jsr 	xbm2mmp
	
	mov 	1,d0
	mov 	d0,(flag_read)
	sub 	d0,d0
	mov 	d0,(flag_laun)
	jsr 	restart_timer
	jmp 	fds_end
fas_ri_nosupport:
	jmp 	fas_end
fas_ri_fatal:
	sub 	d0,d0
	mov 	d0,(flag_noload)
	jmp 	fas_end
fas_ri_end:
	jmp 	fas_end
fas_en:
	mov 	(flag_en),d0
	cmp 	1,d0
	bne 	fas_me

	jmp 	fas_ri_common
fas_me:
	mov 	(flag_me),d0
	cmp 	1,d0
	bne 	fas_fi


	nop

	jmp 	fas_end
fas_fi:
	mov 	(flag_fi),d0
	cmp 	1,d0
	bne 	fas_end

	sub 	d0,d0
	mov 	d0,(flag_laun)
	jsr 	restart_timer
	jmp 	fas_end
fas_end:
#	nop
file_launcher_get_section: 						##==================< GET
fgs:
	mov 	(flag_noload),d0
	cmp 	1,d0
	beq 	fds
##!
	mov 	dta_area,a1
	jsr 	call_dos_setdta
##!
	mov 	pass_name_shadow,a1
	mov 	PASS_RANGE,d1
	jsr 	clear_vram_e

	mov 	filer_buffer,a1
	mov 	14*GET_FILE_MAX,d1
	jsr 	clear_vram_e

	mov 	pass_name,a1
	jsr 	fix_pass_name

	mov 	pass_name,a0
	mov 	pass_name_shadow,a1
	mov 	PASS_RANGE,d1
	jsr 	copy_data

	mov 	search_mode,a0
	mov 	filer_buffer,a1
	mov 	pass_name_shadow,a2 		#shadow => broken
	mov 	file_list,d3
	jsr 	find_file
	mov 	d0,(file_max_folder)
	mov 	d1,(file_max_file)
	cmp 	6,d2
	blt 	fgs2
	jmp 	fgs3
fgs2:
 	mov 	d2,(line_max)
	jmp 	fgs4
fgs3:
	mov 	6,d0
	mov 	d0,(line_max)
fgs4:
	mov 	d2,(file_max)
	mov 	d2,(top_file_max)
file_launcher_sort_section: 					##==================< SORT
fss:
	mov 	(file_max_folder),d1
	cmp 	0,d1
	beq 	fss3

	mov 	(sort_depth),d3
fss2:
	add 	-2,a3
	mov 	d3,(a3)

	mov 	file_list,a0
	mov 	merge_work_area,a1
	sub 	d0,d0
	mov 	(file_max_folder),d1
	add 	-1,d1 								# check ! (n-1)
	mov 	(a3),d2
	jsr 	merge_sort 							# for folders

	mov 	(a3),d3
	add 	2,a3

	add 	-1,d3
	bne 	fss2
fss3:
	mov 	(file_max_file),d1
	cmp 	0,d1
	beq 	fss_end

	mov 	(sort_depth),d3
fss4:
	add 	-2,a3
	mov 	d3,(a3)

	mov 	file_list,a0
	mov 	merge_work_area,a1
	mov 	(file_max_folder),d1
	add 	d1,d1
	add 	d1,d1 								#x4
#	mov 	4,d0
#	mulu 	d0,d1
	add 	d1,a0
	sub 	d0,d0
	mov 	(file_max_file),d1
	add 	-1,d1
	mov 	(a3),d2
	jsr 	merge_sort 							# for files

	mov 	(a3),d3
	add 	2,a3
	add 	-1,d3
	bne 	fss4
fss_end:
	mov 	1,d0
	mov 	d0,(flag_noload)
file_launcher_disp_section: 					##==================< DISP
fds:
fds_create_window:
	mov 	vram+4,a0
	mov 	(file_max),d0
	mov 	d0,d2
	cmp 	6,d0
	blt 	fds_create_window2 					# 6 > file_max
	mov 	6,d2
	jmp 	fds_create_window4
fds_create_window2:
	mov 	vram+4+102*6,a0
fds_create_window3:
	add 	-102,a0
	cmp 	0,d0
	beq 	fds_create_window4
	add 	-1,d0
	bne 	fds_create_window3
fds_create_window4:
	mov 	LAUNCHER_SIZE,d1

	add 	-4,a3
	mov 	a0,(a3)
	jsr 	create_blank_window
	mov 	(a3),a0
fds_text:
	add 	102,a0
	mov 	file_list,a1
	mov 	(top_file_num),d1
	mov 	(file_max),d2
	jsr 	disp_buffered_files

fds_reverse:
	mov 	(a3),a0
	add 	4,a3
	
	add 	102+1,a0
	mov 	(line_num),d0
	mov 	102,d1
	mulu 	d1,d0
	add 	d0,a0

	mov 	58,d1
	jsr 	reverse_area
#fds_launcher_icon:
#	mov 	icon_open,a1
#	mov 	vram+4+102*7,a0
	
#	mov 	8,d3
#fds_launcher_icon2:
#	movbu 	(0,a1),d0
#	movbu 	(0,a0),d1
#	or 		d1,d0
#	movb 	d0,(0,a0)
#	
#	add 	1,a0
#	add 	1,a1
#	add 	-1,d3
#	bne 	fds_launcher_icon2
fds_end:
	jsr 	lcd_display
	jmp 	clear_section

## DATA
	.align 2

launch_pass 		: 	.fill PASS_RANGE,1,0 					#B:\\*
#launch_file_type 	: 	.fill 6,1,0 							#( exf sub txt mmp etc.)

launch_file_size 	: 	.int 0

line_num 			:	.short 0 								# reverse
line_max 			: 	.short 6

file_num 			: 	.short 0 								# selected
file_max 			: 	.short 0
file_max_file 		: 	.short 0
file_max_folder 	: 	.short 0

top_file_num 		:	.short 0 								# top
top_file_max 		:	.short 0

flag_mode 			: 	.short 0
sort_depth 			: 	.short 12

flag_noload 		: 	.short 0
back_mode 			: 	.short 1 								#0(limit) / 1(free)

	.align 2
pass_range 			: 	.short PASS_RANGE

#pass_name 			: 	.fill PASS_RANGE,1,0
#pass_name 			: 	.asciz "B:\\SYSTEM\\YUI\\CMN\\" 					# !
pass_name 			: 	.asciz "B:\\"
 						.fill PASS_RANGE,1,0 								# <-CHECK!
limit_pass 			: 	.asciz "B:\\SYSTEM\\YUI\\"
						.fill PASS_RANGE,1,0
	.align 2
pass_name_shadow 	: 	.fill PASS_RANGE,1,0
dta_area 			: 	.fill 44,1,0

search_mode 		: 	.asciz "*.*" 										# !

	.align 2
allowed_file_type 	: 	.short 2 											#MAX
 						.asciz "xbm"
 						.asciz "XBM"

	.align 2

#	file_list : .fill 4*GET_FILE_MAX,1,0
#	filer_buffer: .fill  14*GET_FILE_MAX,1,0

	.lcomm file_list 		, 4*GET_FILE_MAX 						#list (pt to filer_buffer)
	.lcomm merge_work_area 	, 4*GET_FILE_MAX
	.lcomm filer_buffer 	, 14*GET_FILE_MAX 						#file buffer




## SUB ROUTINEs
#===============================
#	Create Launch Pass
#===============================
#(INPUT)
#a0:launch pass
#a1:current pass
#a2:file list

create_launch_pass:
#	nop
create_launch_pass2:
	movbu 	(0,a1),d0
	movb 	d0,(0,a0)
	cmp 	NULL,d0
	beq 	create_launch_pass3
	add 	1,a0
	add 	1,a1
	jmp 	create_launch_pass2
create_launch_pass3:
	mov 	(file_num),d0
	add 	d0,d0
	add 	d0,d0 					#x4
	add 	d0,a2
	mov 	(a2),a1
	mov 	a1,a2
	add 	1,a2
create_launch_pass4:
	movbu 	(0,a2),d0
	movb 	d0,(0,a0)
	cmp 	NULL,d0
	beq 	create_launch_pass_end
	add 	1,a0
	add 	1,a2
	jmp 	create_launch_pass4
create_launch_pass_end:
	rts

#===============================
#		CHECK EXT
#===============================
#(INPUT)
#a1:pass
#a2:allowed extention
#(OUTPUT)
#d0 : 0(OK) / 1(NON-MATCH) / 2(FATAL)

check_ext:
	add 	-10,a3
check_ext1:
	movbu 	(0,a1),d0
	cmp 	'.',d0
	beq 	check_ext2
	cmp 	NULL,d0
	beq 	check_ext_error2
	add 	1,a1
	jmp 	check_ext1
check_ext2:
	add 	1,a1
	mov 	(a2),d3 					#MAX
	add 	SIZE_SHORT,a2
	
	mov 	a1,(a3)
#	mov 	a2,(4,a3)
check_ext2_2:
	mov 	a2,(4,a3)
	mov 	(a3),a1
	mov 	d3,(8,a3)
	jsr 	compare_str
	mov 	(8,a3),d3
	cmp 	1,d0
	beq 	check_ext_end
	
	add 	-1,d3
	beq 	check_ext_error1
check_ext3:
	mov 	(4,a3),a2
check_ext4:
	movbu 	(0,a2),d0
	add 	1,a2
	cmp 	NULL,d0
	beq 	check_ext2_2
	jmp 	check_ext4
check_ext_end:
	sub 	d0,d0
	add 	10,a3
	rts
check_ext_error1:
	mov 	1,d0
	add 	10,a3
	rts
check_ext_error2:
	mov 	2,d0
	add 	10,a3
	rts



#===============================
#		NEXT DIR
#===============================
#(input)
#a1:original pass
#a2:file name

next_dir:
	movbu 	(0,a1),d0
	cmp 	NULL,d0
	beq 	next_dir2
	add 	1,a1
	jmp 	next_dir
next_dir2:
	movbu 	(0,a2),d0
	cmp 	NULL,d0
	beq 	next_dir3
	movb 	d0,(0,a1)
	add 	1,a1
	add 	1,a2
	jmp 	next_dir2
next_dir3:
	mov 	'\\',d0
	sub 	d1,d1
 	movb 	d0,(0,a1)
	movb 	d1,(1,a1)
next_dir_end:
	rts

#===============================
#		BACK DIR
#===============================
#(INPUT)
#a1:pass
#a2:limit <- use in limit-mode only.
#d1: 0(limit-mode) / 1(free-mode)
#(OUTPUT)
#d0: 0:back-succeed / 1:back-cancelled

back_dir:
	add 	-4,a3

	cmp 	1,d1
	beq 	back_dir3
	
	mov 	a1,(a3)
	jsr 	compare_str
	cmp 	1,d0
	beq 	back_dir_end_stay
	mov 	(a3),a1
back_dir3:
	movbu 	(1,a1),d0
	cmp 	NULL,d0
	beq 	back_dir4
	add 	1,a1
	jmp 	back_dir3
back_dir4:
	movbu 	(-1,a1),d0
	cmp 	':',d0
	beq 	back_dir_end_stay
back_dir5:
	sub 	d1,d1
	movb 	d1,(0,a1)
	add 	-1,a1
back_dir6:
	movbu 	(0,a1),d0
	cmp 	'\\',d0
	beq 	back_dir_end
	movb 	d1,(0,a1) 				#clear
	add 	-1,a1
	jmp 	back_dir6
back_dir_end:
	add 	4,a3
	sub 	d0,d0
	rts
back_dir_end_stay:
	add 	4,a3
	mov 	1,d0
	rts

#===============================
# 	Compare Str
#===============================
#(INPUT)
#a1:str 1
#a2:srt 2
#(OUTPUT)
#d0: 0(un-match) /1(match)

compare_str:
	mov 	a1,a0
	jsr 	word_count
	mov 	d1,d2
	mov 	a2,a0
	jsr 	word_count
	mov 	d1,d3
	cmp 	d2,d3
	bne 	compare_str_end0
compare_str2:
	movbu 	(0,a1),d2
	movbu 	(0,a2),d3
	cmp 	d2,d3
	bne 	compare_str_end0
	cmp 	NULL,d2
	beq 	compare_str_end1
	
	add 	1,a1
	add 	1,a2
	jmp 	compare_str2
compare_str_end0:
	sub 	d0,d0
	rts
compare_str_end1:
	mov 	1,d0
	rts

#===============================
#	DISP BUFFERED FILES
#===============================
#(INPUT)
#a0:VRAM (even)
#a1:file list
#d1:top file num
#d2:file max

disp_buffered_files:
dbf:
	add 	-14,a3
	mov 	a0,(a3)
	mov 	a1,(4,a3)
	mov 	d1,(8,a3)
	mov 	d2,(10,a3)
	cmp 	0,d2
	beq 	dbf_empty
dbf_count:
	sub 	d1,d2 				# max - num
	cmp 	6,d2
	bge 	dbf_count_6over
	jmp 	dbf_count_end
dbf_count_6over:
	mov 	6,d2
dbf_count_end:
	mov 	d2,(12,a3) 			# loop counter
dbf_text:
	mov 	d2,d3
	mov 	4,d0
	mov 	(8,a3),d1
	mulu 	d1,d0
	mov 	(a3),a0
	mov 	(4,a3),a2
	add 	d0,a2
dbf_text2:
	mov 	(a2),a1
	add 	1,a1
	
	add 	-8,a3
	mov 	a0,(a3)
	mov 	a2,(4,a3)
	add 	2,a0
	jsr 	str2vram
	mov 	(a3),a0
	mov 	(4,a3),a2
	add 	8,a3
	
	add 	102,a0
	add 	4,a2
	add 	-1,d3
	bne 	dbf_text2
dbf_icon: 						# icon image <= MENU.s
	mov 	(a3),a0
	mov 	(4,a3),a2
	mov 	(8,a3),d1
	mov 	4,d0
	mulu 	d1,d0
	add 	d0,a2
	mov 	(12,a3),d3
dbf_icon2:
	mov 	(a2),a1
	movbu 	(0,a1),d0
	btst 	0b00010000,d0 				#DIR?
	beq 	dbf_icon2_exec 				#JMP -> NOT DIR
	mov 	next_icon,a1
	jmp 	dbf_icon3
dbf_icon2_exec:
	mov 	exec_icon,a1
dbf_icon3:
	add 	-8,a3
	mov 	a0,(a3)
	mov 	a1,(4,a3)
	add 	LAUNCHER_SIZE-5,a0
	jsr 	symbol2vram4x8
	mov 	(a3),a0
	mov 	(4,a3),a1
	add 	8,a3
	
	add 	102,a0
	add 	4,a2
	add 	-1,d3
	bne 	dbf_icon2
	jmp 	dbf_end
dbf_empty:
	add 	16,a0
	mov 	char_empty,a1
	jsr 	str2vram
dbf_end:
	add 	14,a3
	rts

 	char_empty: 	.asciz "EMPTY.."


#===============================
#	CALL DOS SET DTA
#===============================
#(INPUT)
#a1:DTA-address <- 44bytes required

call_dos_setdta:
	add 	-4,a3
	mov 	a1,(a3)
	jsr 	reset_dos_workarea
	mov 	dos_workarea,a0
	
	mov 	(a3),d0
	mov 	d0,(REG_DX,a0)
	mov 	(2,a3),d0
	mov 	d0,(REG_DS,a0)
	
	mov 	DOS_FSETDTA,d0
	jsr 	call_psdos 				#SET!
	
	add 	4,a3
	rts

#===============================
#		ADD DIR CHAR
#===============================
#ADD '\\' to END OF pass name
#but, already '\\' , do nothing.
#a1:PASS
fix_pass_name:
	movbu 	(0,a1),d0
	cmp 	0,d0
 	beq 	fix_pass_name2
	add 	1,a1
	jmp 	fix_pass_name
fix_pass_name2:
	movbu 	(-1,a1),d0
	cmp 	'\\',d0
	beq 	fix_pass_name_end
	mov 	'\\',d0
	movb 	d0,(0,a1)
	sub 	d0,d0
	movb 	d0,(1,a1) 							#(NULL)
fix_pass_name_end:
 	rts

#===============================
# 	 FIND FILE (except ./ ../)
#===============================
#(INPUT)
#a0:search modei"*.*" , "*.snd" etc..j
#a1:file_buffer
#a2:PASS 
#d3:file_list (address)
#(OUTPUT)
#d0:file max (DIR)
#d1:file max (ARCHIVE)
#d2:file max sum (DIR+ARCHIVE)
#d3: 0:OK/1:ERROR(no files detected)

	.align 2
pass_mirror 			: 	.fill PASS_RANGE,1,0
search_mode_dir 		: 	.asciz "*"

find_file:
	add 	-20,a3
	mov 	a0,(a3)
	mov 	a1,(4,a3)
	mov 	a2,(8,a3)
	movx 	d3,(12,a3)
find_file_dir: 								#Find DIR
	mov 	a2,a0
	mov 	pass_mirror,a1
	mov 	PASS_RANGE,d1
	jsr 	copy_data

	mov 	pass_mirror,a2
	mov 	search_mode_dir,a0
find_file_dir_apply_mode:
	movbu 	(0,a2),d0
	cmp 	NULL,d0
	beq 	find_file_dir_apply_mode2
	add 	1,a2
	jmp 	find_file_dir_apply_mode
find_file_dir_apply_mode2:
	movbu 	(0,a0),d0
	movb 	d0,(0,a2)
	cmp 	NULL,d0
	beq 	find_file_dir2
	add 	1,a0
	add 	1,a2
	jmp 	find_file_dir_apply_mode2
find_file_dir2:
	mov 	0x10,d0 						#dir_only
	mov 	pass_mirror,a1
	jsr 	call_dos_fnd_first
	cmp 	1,d0 							#1=false
	beq 	find_file_error_end
	sub 	d3,d3
	mov 	dta_area+30,a1
	jsr 	check_filer_killers
	cmp 	0,d0 							#0:OK
	bne 	find_file_dir3

	mov 	(4,a3),a1 						#a1:filer_buffer
	mov 	(12,a3),a2 						#a2:file_list(pt)
	mov 	a1,(a2)
	add 	4,a2
	mov 	a2,(12,a3)

	mov 	dta_area+30,a0
	mov 	14,d1
	jsr 	copy_data

	add 	1,d3
find_file_dir3:
	nop
#	mov		1,d3 							#check !
find_file_dir4:
	mov 	d3,(16,a3)
	jsr 	call_dos_fnd_next
	mov 	(16,a3),d3
	cmp 	1,d0 							#1=false
	beq 	find_file_dir_end

	mov 	dta_area+30,a1
	jsr 	check_filer_killers
	cmp 	0,d0 							#0:OK
	bne 	find_file_dir4

	mov 	(4,a3),a1
	jsr 	adjust_filer_buffer 			#d3<-num
	mov 	(12,a3),a2
	mov 	a1,(a2)
	add 	4,a2
	mov 	a2,(12,a3)

	mov 	dta_area+30,a0
	mov 	14,d1
	jsr 	copy_data
	add 	1,d3
	cmp 	GET_FILE_MAX,d3 				#MAX
	blt 	find_file_dir4
	jmp 	find_file_end
find_file_dir_end:
	mov 	d3,(18,a3)
find_file_file:
	mov 	(8,a3),a2
	mov 	(a3),a0
find_file_file_apply_mode:
	movbu 	(0,a2),d0
	cmp 	0,d0
	beq 	find_file_file_apply_mode2
	add 	1,a2
	jmp 	find_file_file_apply_mode
find_file_file_apply_mode2:
	movbu 	(0,a0),d0
	movb 	d0,(0,a2)
	cmp 	0,d0
	beq 	find_file_file2
	add 	1,a0
	add 	1,a2
	jmp 	find_file_file_apply_mode2
find_file_file2:
	mov 	0x20,d0 						#0x20:archive_only
	mov 	(8,a3),a1
	jsr 	call_dos_fnd_first
	cmp 	1,d0 							#1=false
	beq 	find_file_end
	
	mov 	(16,a3),d3
	mov 	(4,a3),a1
 	jsr 	adjust_filer_buffer
	mov 	(12,a3),a2
	mov 	a1,(a2)
	add 	4,a2
	mov 	a2,(12,a3)

	add 	1,d3
	mov 	d3,(16,a3)
	mov 	dta_area+30,a0
	mov 	14,d1
	jsr 	copy_data
find_file_file3:
	mov 	d3,(16,a3)
	jsr 	call_dos_fnd_next
	mov 	(16,a3),d3
	cmp 	1,d0 							#1=false
	beq 	find_file_end

	mov 	(4,a3),a1
	jsr 	adjust_filer_buffer
	mov 	(12,a3),a2
	mov 	a1,(a2)
	add 	4,a2
	mov 	a2,(12,a3)

	mov 	dta_area+30,a0
	mov 	14,d1
	jsr 	copy_data
	add 	1,d3
	cmp 	GET_FILE_MAX,d3 				#MAX
	blt 	find_file_file3 
find_file_end:
	mov 	d3,d1
	mov 	(18,a3),d0 						#d0:folder max
	sub 	d0,d1 							#d1:file max
	mov 	d3,d2 							#d2:folder + file
	sub 	d3,d3 							#d3:error code
	add 	20,a3
	rts
find_file_error_end:
	sub 	d0,d0
	sub 	d1,d1
	sub 	d2,d2
	mov 	1,d3
	add 	20,a3
	rts

#===================
# Adjust FILER BUFFER
#===================
#(INPUT)
#a1:filer_buffer
#d3:file_num

adjust_filer_buffer:
	jsr 	reset_mdr_with_d0
	mov 	d3,d0
	mov 	14,d2
	mulu 	d2,d0
	add 	d0,a1 							#fix
	rts


#===============================
#	CALL DOS FND FIRST
#===============================
#(INPUT)
#d0:find mode
#(bit0:read_only/b1:hidden/b2:system/b3:volume/b4:folder/b5:archive)
#a1:file name address
#(OUTPUT)
#d0:OK(0)/error(1)
#DTA:GOT

call_dos_fnd_first:
	add 	-6,a3
	mov 	d0,(a3)
	mov 	a1,(2,a3)
	
	jsr 	reset_dos_workarea
	mov 	dos_workarea,a0
call_dos_fnd_first2:
	sub 	d0,d0
	mov 	d0,(REG_AL,a0)
	mov 	(a3),d0
	mov 	d0,(REG_CX,a0)
	mov 	(2,a3),d0
	mov 	d0,(REG_DX,a0)
	mov 	(4,a3),d0
	mov 	d0,(REG_DS,a0)

	mov 	DOS_FND_FIRST,d0
	jsr 	call_psdos
	
	mov 	(REG_CF,a0),d0 			#return code
call_dos_fnd_first3:
	add 	6,a3
	rts

#===============================
#	CALL DOS FND NEXT
#===============================
#only first -> next 
#(INPUT)
# NONE (first)
#(OUTPUT)
#d0:OK(0)/ERROR(1)
#DTA:GOT

call_dos_fnd_next:
	jsr 	reset_dos_workarea
	mov 	dos_workarea,a0
	mov 	DOS_FND_NEXT,d0
	jsr 	call_psdos
	mov 	(REG_CF,a0),d0 			#return code
	rts

#===============================
#	Copy Data short
#===============================
#a0:copy from..
#a1:copy to..
#d1:copy range

copy_data_s:
	movb 	(0,a0),d0
	movb 	d0,(0,a1)
	add 	1,a0
	add 	1,a1
	add 	-1,d1
	bne 	copy_data_s
	rts

#===============================
#	 check filer killers
#===============================
#check ./ (crt dir) , ../(par dir)
#(IN)
#a1:filer_buffer
#(OUT)
#d0:0(O.K.) / 1(./) / 2(../)

check_filer_killers:
	movbu 	(1,a1),d0
	cmp 	'.',d0
	beq 	check_filer_killers2
	jmp 	check_filer_killers_end
check_filer_killers2:
	movbu 	(2,a1),d0
	cmp 	NULL,d0
	beq 	check_filer_killers_end1			#./
	cmp 	'.',d0
	beq 	check_filer_killers3
	jmp 	check_filer_killers_end
check_filer_killers3:
	movbu 	(3,a1),d0
	cmp 	NULL,d0
	beq 	check_filer_killers_end2 			#../
check_filer_killers_end:
	sub 	d0,d0
	rts
check_filer_killers_end1:
	mov 	1,d0
	rts
check_filer_killers_end2:
	mov 	2,d0
	rts

#================================
#	Merge Sort
#================================
#from Software Technology [13] pp267-268(ISBN4-87408-414-1 C3055)
#Original src is C , I modified and translated it to ASM.
#(INPUT)
#a0:file list  (address list of filer buffer)
#a1:work area  <-CHECK!
#d0:sort first (num)
#d1:sort last  (num)
#d2:sort range (1->MAX)
#(OUTPUT)
# file list(unsort) -> file list(sort)

merge_sort:
	add 	-28,a3
	mov 	d0,(a3) 				# PUSH ALL
	mov 	d1,(2,a3)
	mov 	d2,(4,a3)
#	mov 	d3,(6,a3)
	mov 	a0,(8,a3)
	mov 	a1,(12,a3)
#	mov 	a2,(16,a3)
merge_sort2: 						#if (first < last) {
	cmp 	d0,d1
	ble 	merge_sort_end
merge_sort3: 						#middle = (first + last) / 2;

	add 	d0,d1
#	sub 	d3,d3
#	mov 	d3,mdr
#	mov 	2,d3
#	divu 	d3,d1
	lsr 	d1 						#/2
	mov 	d1,(20,a3) 				#(20,a3) : middle
merge_sort4: 						#mergesort(first, middle);
	mov 	(a3),d0
	mov 	(4,a3),d2
	jsr 	merge_sort

	mov 	(8,a3),a0
	mov 	(12,a3),a1
merge_sort5: 						#mergesort(middle + 1, last);
	mov 	(20,a3),d0
	add 	1,d0
	mov 	(2,a3),d1
	mov 	(4,a3),d2
	jsr 	merge_sort

	mov 	(8,a3),a0
	mov 	(12,a3),a1
merge_sort6: 						#p = 0;
	sub 	d3,d3 					#d3 : p = 0
	mov 	(a3),d1 				#d1 : i = first 
merge_sort7: 						#for (i = first; i <= middle; i++) work[p++] = a[i];
	mov 	(20,a3),d2 				#middle
	cmp 	d1,d2
	blt 	merge_sort8
	
	mov 	(8,a3),a0
	mov 	d1,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d1,d0
	add 	d0,a0 					#a[i]
	
	mov 	(12,a3),a1
	mov 	d3,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d3,d0
	add 	d0,a1 					#work[p++]
	
	mov 	(a0),a2
	mov 	a2,(a1) 				#a[i] -> work[p++]
	
	add 	1,d3
	add 	1,d1
	jmp 	merge_sort7
merge_sort8: 						#i = middle + 1; j = 0; k =first;
	mov 	d3,(22,a3) 				#(22,a3) : p

	mov 	(20,a3),d1
	add 	1,d1 					#d1: i = middle + 1
	sub 	d2,d2 					#d2: j = 0
	mov 	(a3),d3 				#d3: k = first
merge_sort9: 						#while (i <= last && j < p)
	mov 	(2,a3),d0
	cmp 	d1,d0
	bge 	merge_sort10
	jmp 	merge_sort14
merge_sort10:
	mov 	(22,a3),d0
	cmp 	d2,d0
	bgt 	merge_sort11
	jmp 	merge_sort14
merge_sort11: 						#if (work[j].key <= a[i].key) a[k++] = work[j++];
	mov 	(8,a3),a0
	mov 	d1,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d1,d0
	add 	d0,a0
	
	mov 	(12,a3),a1
	mov 	d2,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d2,d0
	add 	d0,a1
	
	mov 	d1,(24,a3) 				#i : escape
	mov 	d2,(26,a3) 				#j : escape

	mov 	(a0),a2
	mov 	(4,a3),d0
	movbu 	(d0,a2),d1
	mov 	(a1),a2
	movbu 	(d0,a2),d2

	cmp 	d2,d1
	blt 	merge_sort13
merge_sort12:
	mov 	(24,a3),d1 				#i : return
	mov 	(26,a3),d2 				#j : return
	
	mov 	(8,a3),a0
	mov	 	(12,a3),a1
	mov 	d3,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d3,d0
	add 	d0,a0 					#a[k]

	mov 	d2,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d2,d0
	add 	d0,a1 					#work[j]
	
	mov 	(a1),a2
	mov 	a2,(a0) 				#work[j] -> a[k]
	
	add 	1,d2 					#j++
	add 	1,d3 					#k++
	jmp 	merge_sort9
merge_sort13: 						#else 	a[k++] = a[i++];
	mov 	(24,a3),d1 				#i : return
	mov 	(26,a3),d2 				#j : return

	mov 	(8,a3),a0
	mov 	(8,a3),a1
	mov 	d3,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d3,d0
	add 	d0,a0 					#a[k]

	mov 	d1,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d1,d0
	add 	d0,a1 					#a[i]
	
	mov 	(a1),a2
	mov 	a2,(a0)
	
	add 	1,d1 					#i++
	add 	1,d3 					#k++
	jmp 	merge_sort9
merge_sort14: 						#while (j < p) a[k++] = work[j++];
	mov 	(22,a3),d0 				#d0 : p
	cmp 	d2,d0
	ble 	merge_sort_end

	mov 	(8,a3),a0
	mov 	(12,a3),a1
	mov 	d3,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d3,d0
	add 	d0,a0

	mov 	d2,d0
	add 	d0,d0
	add 	d0,d0 					#x4
#	mov 	4,d0
#	mulu 	d2,d0
	add 	d0,a1
	
	mov 	(a1),a2
	mov 	a2,(a0)
	
	add 	1,d2 					#j++
	add 	1,d3 					#k++

	jmp 	merge_sort14
merge_sort_end:
	mov 	(a3),d0 				#POP ALL
	mov 	(2,a3),d1
	mov 	(4,a3),d2
#	mov 	(6,a3),d3
	mov 	(8,a3),a0
	mov 	(12,a3),a1
#	mov 	(16,a3),a2
	add 	28,a3
	rts




# icon_open: .byte 0x56,0xac,0x70,0xa0,0x60,0x80,0xfc,0x02
 icon_open: .byte 0xfe,0xfc,0xf0,0xe0,0xc0,0x80,0xfc,0x02


