#=====================
#	XBMMP
#=====================
#=======================
#	Include Init
#=======================
#	.include	"bioscall.def"
#	.include	"address.def"

	.include	"y_equ.def"
	.text
	.global	_start

#=======================
#	EXF Header
#=======================
_start:
	jmp 	main
	nop
	nop
	nop
	
	.fill 128,1,0 			#ICON etc.

#=======================
#	Main
#=======================
main:
	jsr 	reg_ini
	jsr 	get_psp
	jsr 	reset_dos_workarea
	jsr 	clear_vram
main_first:
	jsr 	main_clear_buffer
	
	mov 	1,d0
	mov 	d0,(flag_lock)
main_end_wait:
	jsr 	call_endwaiting
	jsr 	register_task_first
	jmp 	key_section
#########################################################################
########################################################### KEY  SECTION
#########################################################################
key_section:
keyin_loop:
	jsr 	reg_ini
	.include	"DEV_XBMMP/XBMMP_KEYIN.s" 						##<<KEYIN
#	jmp 	keyin_and_filer
another_events: 						#<-[BACK] keyin_and_filer
	movbu 	(RXD_PORT),d1
	btst 	ON_DS,d1
	beq 	another_events2
	jmp 	exit
another_events2:
	mov 	(keyin_workarea),d0 		#Pop : Keyin
key_up: 								##################################### UP
	cmp 	K_UP,d0
	bne 	key_dw
	mov 	1,d0
	mov 	d0,(flag_up)
	jmp 	key_section_end
key_dw: 								##################################### DOWN
	cmp 	K_DOWN,d0
	bne 	key_right
	mov 	1,d0
	mov 	d0,(flag_dw)
	jmp 	key_section_end
key_right: 								##################################### LEFT
	cmp 	K_RIGHT,d0
	bne 	key_left
	mov 	1,d0
	mov 	d0,(flag_ri)
	jmp 	key_section_end
key_left: 								##################################### RIGHT
	cmp 	K_LEFT,d0
	bne 	key_enter
	mov 	1,d0
	mov 	d0,(flag_le)
	jmp 	key_section_end
key_enter: 								##################################### ENTER
	cmp 	K_ENTER,d0
	bne 	key_menu
	mov 	1,d0
	mov 	d0,(flag_en)
	jmp 	key_section_end
key_menu: 								##################################### MENU
	cmp 	K_MENU,d0
	bne 	key_filer
	mov 	1,d0
	mov 	d0,(flag_me)
	jmp 	key_section_end
key_filer: 								##################################### FILER
	cmp 	K_FILER,d0
	bne 	key_timer
	mov 	1,d0
	mov 	d0,(flag_fi)
	jmp 	key_section_end
key_timer: 								##################################### 1Hz KEYIN TIMER
	mov 	1,d0
	mov 	d0,(flag_ti)
#	jmp 	key_section_end
key_section_end:
	jmp 	act_section
#########################################################################
########################################################### ACT SECTION
#########################################################################
act_section:
as:
	mov 	(flag_menu),d0
	cmp 	1,d0
	beq 	menu_section
	
	mov 	(flag_sele),d0
	cmp 	1,d0
	beq 	task_selector

	mov 	(flag_laun),d0
	cmp 	1,d0
	beq 	file_launcher
	
	jmp 	as2
	.include	"DEV_XBMMP/MENU.s" 								##<<
	.include 	"TASK_SELECTOR.s" 						##<<COMMON ROUTINEs
	.include 	"DEV_XBMMP/LAUNCHER.s" 							##<<
as2:
	mov 	(flag_lock),d0
	cmp 	1,d0
	beq 	as_lock

	mov 	(flag_abou),d0
	cmp 	1,d0
	beq 	as_about
	
as_normal: 								########### < NORMAL
#	nop
as_normal_up:
	mov 	(flag_up),d0
	cmp 	1,d0
	bne 	as_normal_dw
	
	mov 	1,d0
	mov 	d0,(flag_lock)
	jmp 	as_end
as_normal_dw:
	mov 	(flag_dw),d0
	cmp 	1,d0
	bne 	as_normal_en
	
	mov 	1,d0
	mov 	d0,(flag_sele)
	mov 	d0,(flag_pass)

	jsr 	remove_timer
	jsr 	register_keyin_timer
	jsr 	clone_vram
	jmp 	as_end
as_normal_en:
	mov 	(flag_en),d0
	cmp 	1,d0
	bne 	as_normal_me
	
	mov 	1,d0
	mov 	d0,(flag_lock)
	jmp 	as_end
as_normal_me:
	mov 	(flag_me),d0
	cmp 	1,d0
	bne 	as_normal_fi
	
	mov 	1,d0
	mov 	d0,(flag_menu)
	mov 	d0,(flag_pass)
	jsr 	remove_keyin_timer
	jsr 	remove_timer
	jsr 	clone_vram
	jmp 	as_end
as_normal_fi:
	mov 	(flag_fi),d0
	cmp 	1,d0
	bne 	as_end
	
	nop
	
	jmp 	as_end
as_lock: 								########### < LOCK
	mov 	(flag_pop),d0
	cmp 	1,d0
	beq 	as_pop

as_lock_le:
	mov 	(flag_le),d0
	cmp 	1,d0
	bne 	as_lock_ri
	
	jmp 	as_lock_fi2
as_lock_ri:
	mov 	(flag_ri),d0
	cmp 	1,d0
	bne 	as_lock_en
	
	jmp 	as_lock_me2
as_lock_en:
	mov 	(flag_en),d0
	cmp 	1,d0
	bne 	as_lock_fi
	
	sub 	d0,d0
	mov 	d0,(flag_lock)
	jsr 	remove_keyin_timer
	jmp 	as_end
as_lock_fi:
	mov 	(flag_fi),d0
	cmp 	1,d0
	bne 	as_lock_me
	
as_lock_fi2:
	mov 	1,d0
	mov 	d0,(flag_laun)
	mov 	d0,(flag_pass)
	jsr 	remove_keyin_timer
	jsr 	remove_timer
	jsr 	clone_vram
	jmp 	as_end
as_lock_me:
	mov 	(flag_me),d0
	cmp 	1,d0
	bne 	as_end
	
as_lock_me2:
	mov 	(flag_read),d0
	cmp 	1,d0
	bne 	as_end

	mov 	1,d0
	mov 	d0,(flag_pop)
	mov 	d0,(flag_pass)
	jsr 	remove_keyin_timer
	jsr 	remove_timer
	jsr 	clone_vram

	jmp 	as_end
as_pop: 								########## < POP - UP MENU
as_pop_key:
aspk_up:
	mov 	(flag_up),d0
	cmp 	1,d0
	bne 	aspk_dw
	
	mov 	pop_num,a0
	mov 	pop_max,a1
	jsr 	loop_dw
	jmp 	aspk_end
aspk_dw:
	mov 	(flag_dw),d0
	cmp 	1,d0
	bne 	aspk_le
	
	mov 	pop_num,a0
	mov 	pop_max,a1
	jsr 	loop_up
	jmp 	aspk_end
aspk_le:
	mov 	(flag_le),d0
	cmp 	1,d0
	bne 	aspk_ri
	jmp 	aspk_me2
aspk_ri:
	mov 	(flag_ri),d0
	cmp 	1,d0
	bne 	aspk_en
	jmp 	aspk_en2
aspk_en:
	mov 	(flag_en),d0
	cmp 	1,d0
	bne 	aspk_me
	
	nop 					##<<<<!
aspk_en2:
	mov 	(pop_num),d0
	cmp 	0,d0
	beq 	aspk_en_mmp
	cmp 	1,d0
	beq 	aspk_en_c
	cmp 	2,d0
	beq 	exit
	jmp 	aspk_me
aspk_en_mmp:
	mov 	launch_pass,a0
	mov 	xbmmp_file_pass,a1
	mov 	50,d1
	jsr 	copy_data

	mov 	xbmmp_file_pass,a0
	mov 	char_ext_mmp,a1
	jsr 	change_extname

	mov 	xbmmp_file_pass,a1
	mov 	xbmmp_mmp_buffer,a2
	mov 	xbmmp_mmp_info,a0
	movx 	(0,a0),d1
	jsr 	write_iny

	cmp 	1,d0
	beq 	exit
	
	sub 	d0,d0
	mov 	d0,(flag_noload)
	mov 	d0,(flag_pop)
#	mov 	d0,(line_num)
#	mov 	d0,(file_num)
#	mov 	d0,(top_file_num)
	jsr 	restart_timer
	jmp 	aspk_end
aspk_en_c:
	mov 	xbmmp_mmp_buffer,a0
	mov 	xbmmp_buffer,a1
	mov 	xbmmp_mmp_info,a2
	movx 	(0,a2),d1
	add 	-4,d1 						# ! MMP has 4bytes header.
	jsr 	mmp2asc
	
	add 	-4,a3
	movx 	d3,(0,a3)
	
	mov 	launch_pass,a0
	mov 	xbmmp_file_pass,a1
	mov 	50,d1
	jsr 	copy_data

	mov 	xbmmp_file_pass,a0
	mov 	char_ext_txt,a1
	jsr 	change_extname

	mov 	xbmmp_file_pass,a1
	mov 	xbmmp_buffer,a2
	movx 	(0,a3),d1
	add 	4,a3
	jsr 	write_iny

	cmp 	1,d0
	beq 	exit

	sub 	d0,d0
	mov 	d0,(flag_noload)
	mov 	d0,(flag_pop)
#	mov 	d0,(line_num)
#	mov 	d0,(file_num)
#	mov 	d0,(top_file_num)
	jsr 	restart_timer
	jmp 	aspk_end
aspk_me:
	mov 	(flag_me),d0
	cmp 	1,d0
	bne 	aspk_end

aspk_me2:
	sub 	d0,d0
	mov 	d0,(flag_pop)
	jsr 	restart_timer
	jmp 	aspk_end
aspk_end:
	nop
as_pop_disp:
aspd:
	mov 	vram+4+44+102*2,a0
	mov 	56,d1
	mov 	3,d2
	jsr 	create_blank_window
aspd_text:
	mov 	vram+4+48+102*3,a0
	mov 	char_xbmp_mmp,a1
	jsr 	str2vram

	mov 	vram+4+48+102*4,a0
	mov 	char_xbmp_mmpc,a1
	jsr 	str2vram
	
	mov 	vram+4+48+102*5,a0
	mov 	char_pop_exit,a1
	jsr	 	str2vram
aspd_reverse:
	mov 	(pop_num),d0
	mov 	vram+4+45+102*3,a0
	cmp 	0,d0
	beq 	aspd_reverse_do
	mov 	vram+4+45+102*4,a0
	cmp 	1,d0
	beq 	aspd_reverse_do
	mov 	vram+4+45+102*5,a0
	cmp 	2,d0
	beq 	aspd_reverse_do
aspd_reverse_do:
	mov 	54,d1
	jsr 	reverse_area

as_pop_end:
	jsr 	lcd_display
	jmp 	clear_section


char_xbmp_mmp: 	.asciz "XBM -> MMP"
char_xbmp_mmpc: .asciz "XBM -> MMP/C"
char_pop_exit: 	.asciz "Exit ..."

as_about:
	sub 	d0,d0
	mov 	(flag_up),d1
	add 	d1,d0
	mov 	(flag_dw),d1
	add 	d1,d0
	mov 	(flag_le),d1
	add 	d1,d0
	mov 	(flag_ri),d1
	add 	d1,d0
	mov 	(flag_en),d1
	add 	d1,d0
	mov 	(flag_me),d1
	add 	d1,d0
	mov 	(flag_fi),d1
	add 	d1,d0
	cmp 	1,d0
	blt 	as_about_disp

	sub 	d0,d0
	mov 	d0,(flag_abou)
	
	jsr 	restart_timer
	jmp 	as_about_end
as_about_disp:
	mov 	vram+4+102*2,a0
	mov 	title_about,a1
	mov 	(app_about),d1
	add 	1,d1
	mov 	6,d2
	jsr 	win2vram

	mov 	vram+4+102*3,a0
	add 	12,a0
	mov 	app_about,a1
	mov 	(a1),d3
	add 	2,a1
as_about_disp2:
	mov 	a0,d2
	jsr 	str2vram
	mov 	d2,a0
	
	add 	102,a0
	add 	-1,d3
	bne 	as_about_disp2
as_about_end:
	jsr 	lcd_display
#	jmp 	as_end
as_end:
	jmp 	clear_section
#########################################################################
########################################################### CLEAR SECTION
#########################################################################
clear_section:
cs:
	mov 	(flag_ktim),d0 				#1Hz Keyin TIMER?
	cmp 	1,d0
	beq 	cs_timer
	jmp 	cs2
cs_timer:
	mov 	(flag_ti),d0
	cmp 	1,d0
	bne 	cs_timer_check
	
	mov 	(ct_ti),d0
	add 	1,d0
	mov 	d0,(ct_ti)

cs_timer_check:
	mov 	(ct_ti),d0
	mov 	(ktim_wait),d1
	cmp 	d1,d0
	ble 	cs3
	
	jsr 	remove_keyin_timer 				## TIME OUT
#	jmp 	cs2
cs2:
	jsr 	reset_key_counters
cs3:
	jsr 	reset_key_flags
cs_end:
	jmp 	end_section
#########################################################################
########################################################### END  SECTION
#########################################################################
end_section:
	mov 	(flag_pass),d0
	sub 	d1,d1
	mov 	d1,(flag_pass)
	cmp 	1,d0
	beq 	act_section 				## PASS KEYSECTION (once)

	jmp 	key_section

reset_key_counters:
	sub 	d0,d0
	mov 	d0,(ct_up)
	mov 	d0,(ct_dw)
	mov 	d0,(ct_le)
	mov 	d0,(ct_ri)
	mov 	d0,(ct_en)
	mov 	d0,(ct_me)
	mov 	d0,(ct_fi)
	mov 	d0,(ct_ti)
	rts

reset_key_flags:
	sub 	d0,d0
	mov 	d0,(flag_up)
	mov 	d0,(flag_dw)
	mov 	d0,(flag_le)
	mov 	d0,(flag_ri)
	mov 	d0,(flag_en)
	mov 	d0,(flag_me)
	mov 	d0,(flag_fi)
	mov 	d0,(flag_ti)
	rts

##=====================##
##= MAIN_CLEAR_BUFFER =##
##=====================##
main_clear_buffer:
	rts




##====================
##     XBM TO MMP
##====================
#(INPUT)
#a0:original XBM buffer
#a1:buffer for MMP
#a2:buffer for MMP-SIZE
#(OUTPUT)
#d0: 0(OK) / 1(FATAL) / 2(tooLARGE)


char_width:  .asciz "width "
char_height: .asciz "height "

	.equ 	CHAR_WIDTH_SIZE , 6
	.equ 	CHAR_HEIGHT_SIZE , 7

	.equ 	XBM2MMP_STACK_SIZE , 40

xbm2mmp:
	sub 	XBM2MMP_STACK_SIZE,a3
	mov 	a0,(a3)
	mov 	a1,(4,a3)
	mov 	a2,(8,a3)
xbm2mmp_width:
	mov 	a0,a1

#========='width'===========#
xbm2mmp_width2_w:
	movbu 	(0,a1),d0
	cmp 	'w',d0
	beq 	xbm2mmp_width2_i
	jmp 	xbm2mmp_width2_unmatch
xbm2mmp_width2_i:
	movbu 	(1,a1),d0
	cmp 	'i',d0
	beq 	xbm2mmp_width2_d
	jmp 	xbm2mmp_width2_unmatch
xbm2mmp_width2_d:
	movbu 	(2,a1),d0
	cmp 	'd',d0
	beq 	xbm2mmp_width2_t
	jmp 	xbm2mmp_width2_unmatch
xbm2mmp_width2_t:
	movbu 	(3,a1),d0
	cmp 	't',d0
	beq 	xbm2mmp_width2_h
	jmp 	xbm2mmp_width2_unmatch
xbm2mmp_width2_h:
	movbu 	(4,a1),d0
	cmp 	'h',d0
	beq 	xbm2mmp_width2_space
	jmp 	xbm2mmp_width2_unmatch
xbm2mmp_width2_space:
	movbu 	(5,a1),d0
	cmp 	' ',d0
	beq 	xbm2mmp_width3
#	jmp 	xbm2mmp_width2_unmatch
xbm2mmp_width2_unmatch:
	add 	1,a1
	jmp 	xbm2mmp_width2_w
#========='width'===========#

xbm2mmp_width3:
	add 	CHAR_WIDTH_SIZE,a1
	mov 	a1,a2
	sub 	d3,d3
xbm2mmp_width4:
	movbu 	(0,a2),d0
	cmp 	0x0D,d0 				#<- CR 				OTL
	beq 	xbm2mmp_width5
	cmp 	0x0A,d0 				#<- LF
	beq 	xbm2mmp_width5
	cmp 	'#',d0
	beq 	xbm2mmp_width5 			#<-FOR no 0x0A 
	cmp 	' ',d0
	beq 	xbm2mmp_width5
	add 	1,a2
	add 	1,d3
	jmp 	xbm2mmp_width4
xbm2mmp_width5:
	cmp 	0,d3
	beq 	xbm2mmp_end_error1 		# ?
	cmp 	4,d3
	bge 	xbm2mmp_end_error2 		# XXXX
xbm2mmp_width6: 					# X , XX , XXX
	add 	-1,a2
	movbu 	(0,a2),d1
	sub 	0x30,d1
	mov 	d1,(20,a3)

	add 	-1,d3
	beq 	xbm2mmp_width_end
xbm2mmp_width7:
	add 	-1,a2
	
	movbu 	(0,a2),d0
	sub 	0x30,d0
	mov 	10,d1
	mulu 	d1,d0

	mov 	(20,a3),d1
	add 	d0,d1
	mov	 	d1,(20,a3)
	
	add 	-1,d3
	beq 	xbm2mmp_width_end
xbm2mmp_width8:
	add 	-1,a2

	movbu 	(0,a2),d0
	sub 	0x30,d0
	mov 	100,d1
	mulu 	d1,d0
	mov 	(20,a3),d1
	add 	d0,d1
	mov 	d1,(20,a3)
	
xbm2mmp_width_end:
	sub 	d3,d3
	mov 	d3,mdr
	
	mov 	d1,d0

	mov 	8,d3
	divu 	d3,d0
	mov 	mdr,d0
	cmp 	0,d0
	beq 	xbm2mmp_width_end2

	sub 	d0,d3
	add 	d3,d1
xbm2mmp_width_end2:
	mov 	d1,(20,a3)
	


xbm2mmp_height:
	mov 	(a3),a1

#========='height'===========#
xbm2mmp_height2_h:
	movbu 	(0,a1),d0
	cmp 	'h',d0
	beq 	xbm2mmp_height2_e
	jmp 	xbm2mmp_height2_unmatch
xbm2mmp_height2_e:
	movbu 	(1,a1),d0
	cmp 	'e',d0
	beq 	xbm2mmp_height2_i
	jmp 	xbm2mmp_height2_unmatch
xbm2mmp_height2_i:
	movbu 	(2,a1),d0
	cmp 	'i',d0
	beq 	xbm2mmp_height2_g
	jmp 	xbm2mmp_height2_unmatch
xbm2mmp_height2_g:
	movbu 	(3,a1),d0
	cmp 	'g',d0
	beq 	xbm2mmp_height2_h2
	jmp 	xbm2mmp_height2_unmatch
xbm2mmp_height2_h2:
	movbu 	(4,a1),d0
	cmp	 	'h',d0
	beq 	xbm2mmp_height2_t
	jmp 	xbm2mmp_height2_unmatch
xbm2mmp_height2_t:
	movbu 	(5,a1),d0
	cmp 	't',d0
	beq 	xbm2mmp_height2_space
	jmp 	xbm2mmp_height2_unmatch
xbm2mmp_height2_space:
	movbu 	(6,a1),d0
	cmp 	' ',d0
	beq 	xbm2mmp_height3
#	jmp 	xbm2mmp_height2_unmatch
xbm2mmp_height2_unmatch:
	add 	1,a1
	jmp 	xbm2mmp_height2_h
#========='height'===========#

xbm2mmp_height3:
	add 	CHAR_HEIGHT_SIZE,a1
	mov 	a1,a2
	sub 	d3,d3
xbm2mmp_height4:
	movbu 	(0,a2),d0
	cmp 	0x0D,d0 				#<- CR 			o...rz
	beq 	xbm2mmp_height5
	cmp 	0x0A,d0 				#<- LF
	beq 	xbm2mmp_height5
	cmp 	'#',d0
	beq 	xbm2mmp_height5 		#<-FOR no 0x0A 
	add 	1,a2
	add 	1,d3
	jmp 	xbm2mmp_height4
xbm2mmp_height5:
	cmp 	0,d3
	beq 	xbm2mmp_end_error1 		# ?
	cmp 	4,d3
	bge 	xbm2mmp_end_error2 		# XXXX
xbm2mmp_height6: 					# X , XX , XXX
	mov 	d3,d2
	add 	-1,d2

	movbu 	(d2,a1),d0
	sub 	0x30,d0
	mov 	d0,(22,a3)
	
	add 	-1,d3
	beq 	xbm2mmp_height_end
xbm2mmp_height7:
	mov 	d3,d2
	add 	-1,d2
	
	movbu 	(d2,a1),d0
	sub 	0x30,d0
	mov 	10,d1
	mulu 	d1,d0
	mov 	(22,a3),d1
	add 	d1,d0
	mov	 	d0,(22,a3)
	
	add 	-1,d3
	beq 	xbm2mmp_height_end
xbm2mmp_height8:
	mov 	d3,d2
	add 	-1,d2

	movbu 	(d2,a1),d0
	sub 	0x30,d0
	mov 	100,d1
	mulu 	d1,d0
	mov 	(22,a3),d1
	add 	d1,d0
	mov 	d0,(22,a3)
	
xbm2mmp_height_end:
	nop

xbm2mmp_calc_mmp_x_y:
	mov 	(4,a3),a0
	mov 	(20,a3),d0
	mov 	d0,(a0) 						#MMP - X
	
	mov 	(22,a3),d0
	mov 	8,d1
	sub 	d3,d3
	mov 	d3,mdr
	divu 	d1,d0
	mov 	mdr,d1
	cmp 	0,d1
	beq 	xbm2mmp_calc_mmp_x_y_noremind

	add 	1,d0
	add 	d0,d0 							#x2
	add 	d0,d0 							#x4
	add 	d0,d0 							#x8
	jmp 	xbm2mmp_calc_mmp_x_y_end
xbm2mmp_calc_mmp_x_y_noremind:
	mov 	(22,a3),d0
xbm2mmp_calc_mmp_x_y_end:
	mov 	d0,(2,a0) 						#MMP - Y(multiple of 8) <- restraint
	add 	4,a0
	mov 	a0,(4,a3) 						# ! MMP requires X-Y header(2*2bytes).

xbm2mmp_clear:
	mov 	(-4,a0),d0 						#X
	mov 	(-2,a0),d1 						#Y
	sub 	d3,d3
	mov 	d3,mdr
	mov 	8,d2
	divu 	d2,d1 							#d1 = Y/8
											#clear size = X * Y/8 (bytes)
	mov 	(8,a3),a1
	mov 	d0,(4,a1)
	mov 	d1,(6,a1)

	mulu 	d0,d1
	mov 	a0,a1

	movx 	d1,(30,a3)
	jsr 	clear_vram_p

xbm2mmp_asc2hex:
	mov 	(a3),a0
	mov 	xbm2mmp_workarea,a1
xbm2mmp_asc2hex2_b:
	movbu 	(0,a0),d0
	cmp 	'{',d0
	beq 	xbm2mmp_asc2hex2
	add 	1,a0
	jmp 	xbm2mmp_asc2hex2_b
xbm2mmp_asc2hex2:
	movbu 	(0,a0),d0
	cmp 	'x',d0
	beq 	xbm2mmp_asc2hex3
	cmp 	'}',d0
	beq 	xbm2mmp_asc2hex_end
	add 	1,a0
	jmp 	xbm2mmp_asc2hex2
xbm2mmp_asc2hex3:
	add 	1,a0

	movbu 	(0,a0),d0
	jsr 	asc2num_abcdef
	cmp 	1,d1
	bne 	xbm2mmp_asc2hex3_2
	sub 	0x30,d0
xbm2mmp_asc2hex3_2:
	mov 	16,d2
	mulu 	d2,d0

	mov 	d0,d3

	add 	1,a0
	movbu 	(0,a0),d0
	jsr 	asc2num_abcdef
	cmp 	1,d1
	bne 	xbm2mmp_asc2hex3_3
	sub 	0x30,d0
xbm2mmp_asc2hex3_3:
	add 	d0,d3
	movb 	d3,(0,a1)

	add 	1,a0
	add 	1,a1
	jmp 	xbm2mmp_asc2hex2
xbm2mmp_asc2hex_end:
	nop

xbm2mmp_convert:
	mov 	(20,a3),d0
	sub 	d3,d3
	mov 	d3,mdr
	mov 	8,d1
	divu 	d1,d0
	mov 	d0,(28,a3) 						#WIDTH / 8
	mov 	d0,(34,a3)

	mov 	0x01,d1 						#d1: switcher
	mov 	(4,a3),a0
	mov 	xbm2mmp_workarea,a1
	mov 	a1,(36,a3)
	mov 	(22,a3),d2 						#d2: height(XBM-original)
xbm2mmp_convert2:
	sub 	d3,d3 							#d3: counter
xbm2mmp_convert3:
xbm2mmp_convert3_bit0: 						# o... TZ
	movbu 	(0,a1),d0
	btst 	0b10000000,d0
	beq 	xbm2mmp_convert3_bit1
	movbu 	(7,a0),d0
	or 		d1,d0
	movb 	d0,(7,a0)
xbm2mmp_convert3_bit1:
	movbu 	(0,a1),d0
	btst 	0b01000000,d0
	beq 	xbm2mmp_convert3_bit2
	movbu 	(6,a0),d0
	or 		d1,d0
	movb 	d0,(6,a0)
xbm2mmp_convert3_bit2:
	movbu 	(0,a1),d0
	btst 	0b00100000,d0
	beq 	xbm2mmp_convert3_bit3
	movbu 	(5,a0),d0
	or 		d1,d0
	movb 	d0,(5,a0)
xbm2mmp_convert3_bit3:
	movbu 	(0,a1),d0
	btst 	0b00010000,d0
	beq 	xbm2mmp_convert3_bit4
	movbu 	(4,a0),d0
	or 		d1,d0
	movb 	d0,(4,a0)
xbm2mmp_convert3_bit4:
	movbu 	(0,a1),d0
	btst 	0b00001000,d0
	beq 	xbm2mmp_convert3_bit5
	movbu 	(3,a0),d0
	or 		d1,d0
	movb 	d0,(3,a0)
xbm2mmp_convert3_bit5:
	movbu 	(0,a1),d0
	btst 	0b00000100,d0
	beq 	xbm2mmp_convert3_bit6
	movbu 	(2,a0),d0
	or 		d1,d0
	movb 	d0,(2,a0)
xbm2mmp_convert3_bit6:
	movbu 	(0,a1),d0
	btst 	0b00000010,d0
	beq 	xbm2mmp_convert3_bit7
	movbu 	(1,a0),d0
	or 		d1,d0
	movb 	d0,(1,a0)
xbm2mmp_convert3_bit7:
	movbu 	(0,a1),d0
	btst 	0b00000001,d0
	beq 	xbm2mmp_convert4
	movbu 	(0,a0),d0
	or 		d1,d0
	movb 	d0,(0,a0)
xbm2mmp_convert4:
	mov 	(34,a3),d0
	add 	d0,a1

	add 	-1,d2
	add 	1,d3

	cmp 	0,d2
	beq 	xbm2mmp_convert6
	
	cmp	 	8,d3
	bge 	xbm2mmp_convert5

	add 	d1,d1 							#switcher x2
	jmp 	xbm2mmp_convert3
xbm2mmp_convert5:
	mov 	(20,a3),d0
	add 	d0,a0 							#FIX - VRAM
	mov 	0x01,d1 						#RESET : Switcher
	jmp 	xbm2mmp_convert2
xbm2mmp_convert6:
	mov 	0x01,d1 						#RESET : Switcher

	mov 	(28,a3),d0
	add 	-1,d0
	mov 	d0,(28,a3)
	
	cmp 	0,d0
	ble 	xbm2mmp_convert7
	
	mov 	(22,a3),d2 						#RESET : HEIGHT
	mov 	(4,a3),a0
	add 	8,a0
	mov 	a0,(4,a3) 						#BUFFER : RESET & + 8

	mov 	(36,a3),a1
	add 	1,a1
	mov 	a1,(36,a3)

	jmp 	xbm2mmp_convert2
xbm2mmp_convert7:
	nop

xbm2mmp_mmp_size:
	movx 	(30,a3),d0
	add 	4,d0 							#X-Y header
	mov 	(8,a3),a1
	movx 	d0,(0,a1)

xbm2mmp_end:
	sub 	d0,d0
	add 	XBM2MMP_STACK_SIZE,a3
	rts

xbm2mmp_end_error1: 						#1 : FATAL
	mov 	1,d0
	add 	XBM2MMP_STACK_SIZE,a3
	rts
	
xbm2mmp_end_error2: 						#2 : The XBM is too large to convert.
	mov 	2,d0
	add 	XBM2MMP_STACK_SIZE,a3
	rts



##(INUPUT)
#d0: num
##(OUTPUT)
#d0: if abcdef->10~15 else non-touch
#d1: 1:NOT abcdef or ABCDEF
asc2num_abcdef:
	cmp 	'a',d0
	beq 	asc2num_a
	cmp 	'A',d0
	beq 	asc2num_a
	cmp 	'b',d0
	beq 	asc2num_b
	cmp 	'B',d0
	beq 	asc2num_b
	cmp 	'c',d0
	beq 	asc2num_c
	cmp 	'C',d0
	beq 	asc2num_c
	cmp 	'd',d0
	beq 	asc2num_d
	cmp 	'D',d0
	beq 	asc2num_d
	cmp 	'e',d0
	beq 	asc2num_e
	cmp 	'E',d0
	beq 	asc2num_e
	cmp 	'f',d0
	beq 	asc2num_f
	cmp 	'F',d0
	beq 	asc2num_f
	jmp 	asc2num_abcdef_1end
asc2num_a:
	mov 	10,d0
	jmp 	asc2num_abcdef_0end
asc2num_b:
	mov 	11,d0
	jmp 	asc2num_abcdef_0end
asc2num_c:
	mov 	12,d0
	jmp 	asc2num_abcdef_0end
asc2num_d:
	mov 	13,d0
	jmp 	asc2num_abcdef_0end
asc2num_e:
	mov 	14,d0
	jmp 	asc2num_abcdef_0end
asc2num_f:
	mov 	15,d0
#	jmp 	asc2num_abcdef_0end
asc2num_abcdef_0end:
	sub 	d1,d1
	rts
asc2num_abcdef_1end:
	mov 	1,d1
	rts






#=======================
#	Write INY
#=======================
#INYt@CCgBFXg܂BłReadINY̎g񂵂AƖʂȊB
#íj
#a1:Cgt@C̃pXi[̈̃AhX
#a2:Cgobt@̃AhXiobt@̓Cg͈͈ȏł邱Ɓj
#d1:Cg͈(1byte - 32kbyte)
#iój
#d0: ( 0: , 1:I𐄏,ȂvIȃG[ j

write_iny:
	add 	-12,a3
	
	mov 	a1,(a3) 				#push: &filename
	mov 	a2,(4,a3) 				#push: &buffer
	mov 	d1,(8,a3)  				#push: range
									#c2byte̓t@Cnhp
write_iny_open: 						#INYt@COPEN悤Ǝ݂
	jsr 	reset_dos_workarea
	mov 	dos_workarea,a0
	mov 	1,d0 					#01:[W]
	movb 	d0,(REG_AL,a0) 			#(00:R,01:W,02:R/W)		->AL :8bitWX^
	mov 	(a3),d0 				#pop:&filename(16bit)
	mov 	d0,(REG_DX,a0) 			#&filename 0xXXXX		->DX :16bitWX^
	mov 	(2,a3),d0 				#pop:&filename(8bit + ??)
	mov 	d0,(REG_DS,a0) 			#&filename 0xXX??	->DS :16bitWX^
write_iny_call_dos_open:
	mov 	DOS_OPEN,d0 			#dos_open : 0x3D
	jsr 	call_psdos

write_iny_open_end:
	mov 	(REG_CF,a0),d0 			#CF = (0: , 1=s)
	cmp 	1,d0 					#sH
	beq 	write_iny_create		#΍낤

	mov 	(REG_AX,a0),d0
	mov 	d0,(10,a3) 				#push : file_handle
	
	jmp 	write_iny_write 		#̂Ȃ珑

write_iny_create:
	jsr 	reset_dos_workarea
	mov 	dos_workarea,a0
	mov 	(a3),d0 				#pop:&filenamei16bitj
	mov 	d0,(REG_DX,a0) 			#&filename 0xXXXX		->DX :16bitWX^
	mov 	(2,a3),d0 				#pop:&filenamei8bit + ??j
	mov 	d0,(REG_DS,a0) 			#&filename 0xXX??	->DS :16bitWX^
	mov 	0x20,d0 				#0x20:Archive
	mov 	d0,(REG_CX,a0)
write_iny_call_dos_create:
	mov 	DOS_CREATE,d0
	jsr 	call_psdos
wirte_iny_create_end:
	mov 	(REG_CF,a0),d0
	cmp 	1,d0
	beq 	write_iny_end_err1

	mov 	(REG_AX,a0),d0
	mov 	d0,(10,a3) 				#push : file_handle

	jmp 	write_iny_write
write_iny_write:
	jsr 	reset_dos_workarea
	mov 	dos_workarea,a0
	
	mov 	(4,a3),d0 				#pop : &buffer 0xXXXX
	mov 	d0,(REG_DX,a0) 			# 						->DXWX^
	mov 	(6,a3),d0 				#pop : &buffer 0xXX + ??
	mov 	d0,(REG_DS,a0) 			#&buffer 0xXX?? 	->DSWX^

	mov 	(8,a3),d0 				#pop : range
	mov 	d0,(REG_CX,a0) 			# 						->CXWX^
	
	mov 	(10,a3),d0 				#pop : filehandle
	mov 	d0,(REG_BX,a0) 			# 						->BXWX^
	
write_iny_call_dos_write:
	mov 	DOS_WRITE,d0 			# dos_write :0x40
	jsr 	call_psdos

write_iny_write_end:
	mov 	(REG_CF,a0),d0 			#CF = (0: , 1=s)
	cmp 	1,d0 					#sH
	beq 	write_iny_end_err1		#sȂ΁A^[R[h1ŔB

#	jmp 	write_iny_close 		#Lb`ɍs

write_iny_close: 					#KJt@C͕邱ƁB
	jsr 	reset_dos_workarea
	mov 	dos_workarea,a0
	mov 	(10,a3),d0 				#pop:file_handle
	mov 	d0,(REG_BX,a0) 			# 				->BXWX^
write_iny_call_dos_close:
	mov 	DOS_CLOSE,d0 			#dos_close : 0x3e
	jsr 	call_psdos

write_iny_close_end:
	mov 	(REG_CF,a0),d0 			#CFWX^i0: , 1:ُj
	cmp 	1,d0
	beq 	write_iny_end_err1 		#N[Ys˂...

#	jmp 	read_iny_wrflush

write_iny_wrflush: 					#Ŝ...BȑOɂȂƃZbgŏB
	mov 	BI_WRFLUSH,d0
	jsr 	call_wbios

#	jmp 	write_iny_end

write_iny_end:
	add 	12,a3
	sub 	d0,d0 					#A^[R[h 0
	rts
write_iny_end_err1:
	add 	12,a3
	mov 	1,d0 					#sA^[R[h 1
	rts



#===================
# 	change extname
#===================
##(INPUT)
#a0: pass
#a1: ext
##(OUTPUT)
#d0: 0(succee) / 1(fatal)

change_extname:
	movbu 	(0,a0),d0
	cmp 	'.',d0
	beq 	change_extname1
	cmp 	NULL,d0
	beq 	change_extname_error
	add 	1,a0
	jmp 	change_extname
change_extname1:
	add 	1,a0
change_extname2:
	movbu 	(0,a1),d0
	movb 	d0,(0,a0)
	cmp 	NULL,d0
	beq 	change_extname_end
	
	add 	1,a0
	add 	1,a1
	jmp 	change_extname2
change_extname_end:
	sub 	d0,d0
	rts
change_extname_error:
	mov 	1,d0
	rts


#========================
# 		MMP 2 ASC
#========================
##(INPUT)
#a0:mmp_buffer
#a1:c_buffer
#d1:mmp_size
##(OUTPUT)
#d3:c_buffer_size


	.equ 	MMP2ASC_STACK_SIZE , 8

mmp2asc:
	sub 	MMP2ASC_STACK_SIZE,a3
	add 	4,a0
	movx 	d1,(0,a3)
	sub 	d3,d3
	movx 	d3,(4,a3)
mmp2asc2:
	sub 	d0,d0
	mov 	d0,mdr
	movbu 	(0,a0),d0
	add 	1,a0
	mov 	16,d1
	divu 	d1,d0
	mov 	d0,d2 				#d2:HIGH(UP)
	mov 	mdr,d3 				#d3:LOW (DW)
mmp2asc2_up:
	cmp 	10,d2
	bge 	mmp2asc2_up_abcdef
	add 	0x30,d2
	jmp 	mmp2asc2_up_end
mmp2asc2_up_abcdef:
	add 	-10,d2 				#!
	add 	0x61,d2
mmp2asc2_up_end:
	nop
mmp2asc2_dw:
	cmp 	10,d3
	bge 	mmp2asc2_dw_abcdef
	add 	0x30,d3
	jmp 	mmp2asc2_dw_end
mmp2asc2_dw_abcdef:
	add 	-10,d3 				#!
	add 	0x61,d3
mmp2asc2_dw_end:
	nop
mmp2asc3:
	mov 	' ',d0
	movb 	d0,(0,a1)
	add 	1,a1
	
	mov 	'0',d0
	movb 	d0,(0,a1)
	add 	1,a1
	
	mov 	'x',d0
	movb 	d0,(0,a1)
	add 	1,a1
	
	movb 	d2,(0,a1)
	add 	1,a1
	
	movb 	d3,(0,a1)
	add 	1,a1
	
#	mov 	' ',d0
#	movb 	d0,(0,a1)
#	add 	1,a1
	
	mov 	',',d0
	movb 	d0,(0,a1)
	add 	1,a1
	
	movx 	(4,a3),d3
	add 	6,d3
	movx 	d3,(4,a3)
	
	movx 	(0,a3),d3
	add 	-1,d3
	beq 	mmp2asc_end
	movx 	d3,(0,a3)

	jmp 	mmp2asc2
mmp2asc_end:
	movx 	(4,a3),d3
	add 	MMP2ASC_STACK_SIZE,a3
	rts



	.include	"DEV_XBMMP/XBMMP_TASK.s"
	.include	"DEV_XBMMP/XBMMP_MENU.s"

