
#================================
#	Quick Sort
#================================
#from Software Technology [13] pp55-56(ISBN4-87408-414-1 C3055)
#Original src is C , I modified it and translated it to ASM.
#(INPUT)
#a0:file list  (address list of filer buffer)
#d0:sort first (num)
#d1:sort last  (num)
#d2:sort range (1->MAX)
#(OUTPUT)
# file list(unsort) -> file list(sort)

quick_sort:
	add 	-28,a3
	mov 	d0,(a3) 				# PUSH ALL
	mov 	d1,(2,a3)
	mov 	d2,(4,a3)
	mov 	d3,(6,a3)
	mov 	a0,(8,a3)
	mov 	a1,(12,a3)
	mov 	a2,(16,a3)
quick_sort1: 						# x = a[(first + last) / 2];
	add 	d0,d1
	mov 	2,d2
	sub 	d3,d3
	mov 	d3,mdr 					# mdr -> clear
	divu 	d2,d1

	mov 	4,d2
	mulu 	d2,d1
	mov 	(8,a3),a0
	add 	d1,a0
	mov 	(a0),a1
	mov 	(4,a3),d3
	movbu 	(d3,a1),d1 				# d1:x
	mov 	d1,(20,a3)
quick_sort2: 						# i = first; j = last;
	mov 	(a3),d1
	mov 	(2,a3),d2
quick_sort3: 						# while (a[i] < x) i++;
	mov 	4,d0
	mov 	(8,a3),a0
	mulu 	d1,d0
	add		d0,a0
	mov 	(a0),a1
	mov 	(4,a3),d3
	movbu 	(d3,a1),d0
	mov 	d0,(24,a3)
	mov 	(20,a3),d3 				# x
	cmp 	d0,d3
	ble 	quick_sort4
	add 	1,d1 					# i++
	jmp 	quick_sort3
quick_sort4:
# 	nop
quick_sort5:						# while (x < a[j]) j--;
	mov 	4,d0
	mov 	(8,a3),a0
	mulu 	d2,d0
	add 	d0,a0
	mov 	(a0),a1
	mov 	(4,a3),d3
	movbu 	(d3,a1),d0
	mov 	d0,(26,a3)
	mov 	(20,a3),d3 				# x
	cmp 	d3,d0
	ble 	quick_sort6
	add 	-1,d2 					# j--
	jmp 	quick_sort5
quick_sort6: 						# if (i >= j) break;
	cmp 	d1,d2
	ble 	quick_sort9 			# break
quick_sort7: 						# t = a[i]; a[i] = a[j]; a[j] = t;
#===== Stabilizer =====#(- for a present..)
	mov 	(24,a3),d0
	mov 	(26,a3),d3
	cmp 	d0,d3
	beq 	quick_sort8
#===== Stabilizer =====#
	mov 	(8,a3),a0
	mov 	4,d0
	mulu 	d1,d0
	add 	d0,a0
	mov 	(a0),a2 				# a2=a[i]
	mov 	(8,a3),a1
	mov 	4,d0
	mulu 	d2,d0
	add 	d0,a1
	movx 	(0,a1),d3 				# d3=a[j]
	movx 	d3,(0,a0)
	mov 	a2,(a1) 				# (exchange each address)
quick_sort8: 						# i++; j--;
	add 	1,d1
	add 	-1,d2
	jmp 	quick_sort3
quick_sort9: 						# if (first < i - 1) quicksort(a, first, i - 1);
	mov 	d1,d3
	add 	-1,d3
	mov 	(a3),d0
	cmp 	d0,d3
	ble 	quick_sort10

	mov 	d2,(22,a3)
	mov 	(8,a3),a0
	mov 	d3,d1
	mov 	(4,a3),d2 				#a0:file list / d0:first / d1:last / d2:range
	jsr 	quick_sort
	mov 	(22,a3),d2 				#revive j
quick_sort10: 						# if (j + 1 < last) quicksort(a, j + 1, last);
	mov 	d2,d3
	add 	1,d3
	mov 	(2,a3),d1
	cmp	 	d3,d1
	ble 	quick_sort_end
	
	mov 	(8,a3),a0
	mov 	d3,d0
	mov 	(4,a3),d2 				#a0:file list / d0:first / d1:last / d2:range
	jsr 	quick_sort
quick_sort_end:
	mov 	(a3),d0 				# POP ALL
	mov 	(2,a3),d1
	mov 	(4,a3),d2
	mov 	(6,a3),d3
	mov 	(8,a3),a0
	mov 	(12,a3),a1
	mov 	(16,a3),a2
	add 	28,a3
	rts

#================================
#	Merge Sort
#================================
#from Software Technology [13] pp267-268(ISBN4-87408-414-1 C3055)
#Original src is C , I modified and translated it to ASM.
#(INPUT)
#a0:file list  (address list of filer buffer)
#a1:work area  <-CHECK!
#d0:sort first (num)
#d1:sort last  (num)
#d2:sort range (1->MAX)
#(OUTPUT)
# file list(unsort) -> file list(sort)

merge_sort:
	add 	-28,a3
	mov 	d0,(a3) 				# PUSH ALL
	mov 	d1,(2,a3)
	mov 	d2,(4,a3)
	mov 	d3,(6,a3)
	mov 	a0,(8,a3)
	mov 	a1,(12,a3)
	mov 	a2,(16,a3)
merge_sort2: 						#if (first < last) {
	cmp 	d0,d1
	ble 	merge_sort_end
merge_sort3: 						#middle = (first + last) / 2;

	add 	d0,d1
	sub 	d3,d3
	mov 	d3,mdr
	mov 	2,d3
	divu 	d3,d1
	mov 	d1,(20,a3) 				#(20,a3) : middle
merge_sort4: 						#mergesort(first, middle);
	mov 	(a3),d0
	mov 	(4,a3),d2
	jsr 	merge_sort

	mov 	(8,a3),a0
	mov 	(12,a3),a1
merge_sort5: 						#mergesort(middle + 1, last);
	mov 	(20,a3),d0
	add 	1,d0
	mov 	(2,a3),d1
	mov 	(4,a3),d2
	jsr 	merge_sort

	mov 	(8,a3),a0
	mov 	(12,a3),a1
merge_sort6: 						#p = 0;
	sub 	d3,d3 					#d3 : p = 0
	mov 	(a3),d1 				#d1 : i = first 
merge_sort7: 						#for (i = first; i <= middle; i++) work[p++] = a[i];
	mov 	(20,a3),d2 				#middle
	cmp 	d1,d2
	blt 	merge_sort8
	
	mov 	(8,a3),a0
	mov 	4,d0
	mulu 	d1,d0
	add 	d0,a0 					#a[i]
	
	mov 	(12,a3),a1
	mov 	4,d0
	mulu 	d3,d0
	add 	d0,a1 					#work[p++]
	
	mov 	(a0),a2
	mov 	a2,(a1) 				#a[i] -> work[p++]
	
	add 	1,d3
	add 	1,d1
	jmp 	merge_sort7
merge_sort8: 						#i = middle + 1; j = 0; k =first;
	mov 	d3,(22,a3) 				#(22,a3) : p

	mov 	(20,a3),d1
	add 	1,d1 					#d1: i = middle + 1
	sub 	d2,d2 					#d2: j = 0
	mov 	(a3),d3 				#d3: k = first
merge_sort9: 						#while (i <= last && j < p)
	mov 	(2,a3),d0
	cmp 	d1,d0
	bge 	merge_sort10
	jmp 	merge_sort14
merge_sort10:
	mov 	(22,a3),d0
	cmp 	d2,d0
	bgt 	merge_sort11
	jmp 	merge_sort14
merge_sort11: 						#if (work[j].key <= a[i].key) a[k++] = work[j++];
	mov 	(8,a3),a0
	mov 	4,d0
	mulu 	d1,d0
	add 	d0,a0
	
	mov 	(12,a3),a1
	mov 	4,d0
	mulu 	d2,d0
	add 	d0,a1
	
	mov 	d1,(24,a3) 				#i : escape
	mov 	d2,(26,a3) 				#j : escape

	mov 	(a0),a2
	mov 	(4,a3),d0
	movbu 	(d0,a2),d1
	mov 	(a1),a2
	movbu 	(d0,a2),d2

	cmp 	d2,d1
	blt 	merge_sort13
merge_sort12:
	mov 	(24,a3),d1 				#i : return
	mov 	(26,a3),d2 				#j : return
	
	mov 	(8,a3),a0
	mov	 	(12,a3),a1
	mov 	4,d0
	mulu 	d3,d0
	add 	d0,a0 					#a[k]

	mov 	4,d0
	mulu 	d2,d0
	add 	d0,a1 					#work[j]
	
	mov 	(a1),a2
	mov 	a2,(a0) 				#work[j] -> a[k]
	
	add 	1,d2 					#j++
	add 	1,d3 					#k++
	jmp 	merge_sort9
merge_sort13: 						#else 	a[k++] = a[i++];
	mov 	(24,a3),d1 				#i : return
	mov 	(26,a3),d2 				#j : return

	mov 	(8,a3),a0
	mov 	(8,a3),a1
	mov 	4,d0
	mulu 	d3,d0
	add 	d0,a0 					#a[k]

	mov 	4,d0
	mulu 	d1,d0
	add 	d0,a1 					#a[i]
	
	mov 	(a1),a2
	mov 	a2,(a0)
	
	add 	1,d1 					#i++
	add 	1,d3 					#k++
	jmp 	merge_sort9
merge_sort14: 						#while (j < p) a[k++] = work[j++];
	mov 	(22,a3),d0 				#d0 : p
	cmp 	d2,d0
	ble 	merge_sort_end

	mov 	(8,a3),a0
	mov 	(12,a3),a1
	mov 	4,d0
	mulu 	d3,d0
	add 	d0,a0

	mov 	4,d0
	mulu 	d2,d0
	add 	d0,a1
	
	mov 	(a1),a2
	mov 	a2,(a0)
	
	add 	1,d2 					#j++
	add 	1,d3 					#k++

	jmp 	merge_sort14
merge_sort_end:
	mov 	(a3),d0 				#POP ALL
	mov 	(2,a3),d1
	mov 	(4,a3),d2
	mov 	(6,a3),d3
	mov 	(8,a3),a0
	mov 	(12,a3),a1
	mov 	(16,a3),a2
	add 	28,a3
	rts

